#include "dcdialog.ch"
#INCLUDE "appevent.CH"
#INCLUDE "dcbitmap.CH"
#INCLUDE "dcicon.CH"
#INCLUDE "fileio.CH"

FUNCTION Main()

LOCAL GetList[0], GetOptions, oMenuBar, oMenuFile, nColor,;
      oDlg, oAppWindow := SetAppwindow()


  DCMENUBAR oMenuBar

    DCSUBMENU oMenuFile PROMPT '&File' PARENT oMenuBar MESSAGE 'This is the File Menu'
      DCMENUITEM '~Test Window' PARENT oMenuFile ACTION {|o|o:=Thread():new(),Sleep(5),o:start({||TestWindow(oDlg:drawingArea)})}
      DCMENUITEM 'Item2' PARENT oMenuFile ACTION {||nil}
      DCMENUITEM SEPARATOR PARENT oMenuFile
      DCMENUITEM 'Quit' PARENT oMenuFile ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }


DCGETOPTIONS ;
   NOBUSY ;
   SAYFONT "9.Arial" ;
   GETFONT "9.Courier New" ;
   FONT "9.Arial" ;  //    COLPIXELS 10.0 ;   ROWPIXELS 28 ;   ROWSPACE 10 ;
   TOOLTIPCOLOR GRA_CLR_BLACK, GRA_CLR_YELLOW  //	 ;

DC_GetOptDefault(GetOptions)

DCGETOPTIONS ;  //	 AUTOWINDOWMENU ;
   WINDOWHEIGHT 600 ;
   WINDOWWIDTH 800 ;
	 EVAL {|o|SetAppWindow(o) }


DCGETOPTIONS

DCREAD GUI TITLE 'Test with modal and nonmodal window' ;
  OPTIONS GetOptions ;
  PARENT @oDlg

RETURN nil


PROC appsys ; return

* -----------

STATIC FUNCTION TestWindow( oMainWindow )

LOCAL GetList := {}, GetOptions, oDlgTest, oStatic

@ .1,.1 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 60,15.000 OBJECT oStatic

@ 0,0 DCPUSHBUTTON CAPTION 'Test 1 nonmodal' ACTION {||tw1(oDlgtest)} SIZE 20,1.2 MESSAGE 'This is button 1' PARENT oStatic
@ 2,0 DCPUSHBUTTON CAPTION 'Test 2 modal' ACTION {||tw2(oDlgtest)} SIZE 20,1.2 MESSAGE 'This is button 2' PARENT oStatic
@ 4,0 DCPUSHBUTTON CAPTION 'Test 3' ACTION {||nil} SIZE 20,1.2 MESSAGE 'This is button 3' PARENT oStatic
@ 6,0 DCPUSHBUTTON CAPTION 'Test 4' ACTION {||nil} SIZE 20,1.2 MESSAGE 'This is button 4' PARENT oStatic

DCGETOPTIONS

DCREAD GUI FIT ;
		ADDBUTTONS ;
		TITLE 'Button Test' ;
		APPWINDOW oMainWindow ;
		PARENT @oDlgTest

RETURN nil

* -----------

Function tw1( oDlgtest)
Local GetList := {}, GetOptions, oDlgtw1, oget, cget, oStatic

cget := space(15)

@ .1,.1 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 50,5.000 OBJECT oStatic

@ 2,05 DCSAY "Test-1 " PARENT oStatic
@ 2,20 DCGET cget OBJECT oget PARENT oStatic

DCGETOPTIONS

DCREAD GUI FIT ;
		ADDBUTTONS ;
		TITLE 'Test-nonmodal' ;
		APPWINDOW oDlgtest ;
		PARENT @oDlgtw1 ;
		EVAL{|o|o:SetPos( { 0,0 } ) } ; //, SetAppwindow(o) } ;
		SETFOCUS @oget

RETURN nil



* -----------

Function tw2( oDlgtest)
Local GetList := {}, GetOptions, oDlgtw2, oget, cget, oStatic

cget := space(15)

@ .1,.1 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 50,5.000 OBJECT oStatic

@ 2,05 DCSAY "Test-1 " PARENT oStatic
@ 2,20 DCGET cget OBJECT oget PARENT oStatic


DCGETOPTIONS

DCREAD GUI FIT ;
		MODAL ;
		ADDBUTTONS ;
		TITLE 'Test-modal' ;   //		APPWINDOW ; //  oDlgtest ;   		PARENT @oDlgtw2 ;
		EVAL{|o|SetAppwindow(o) }  ; //, o:SetPos( { 0,0 } ) } ;
		SETFOCUS @oget

RETURN nil

Return NIL
